extends Sprite2D

var drag = false
var hover = 0
var default_scale = 0.28
var obj = true
var type = "player"
var top = ""
var bottom = ""
var move = false
var target = null
var speed = 0
var animka = [0.7,0.9]

func _ready():
	if type == 'player':
		obj = false
		if g.v.top != null: $Top.texture = load("res://Images/player_"+g.v.top+".png")
		if g.v.bottom != null: $Bottom.texture = load("res://Images/player_"+g.v.bottom+".png")
		if g.v.underwear != null: $Underwear.texture = load("res://Images/player_"+g.v.underwear+".png")
		if g.v.footwear != null: $Footwear.texture = load("res://Images/player_"+g.v.footwear+".png")
		if g.v.gestation > 30: texture = load("res://Images/player_body_preg.png")
	if !obj:
		if g.ANDROID == true:
			material = null
		$Anim.speed_scale = g.rndf(animka[0],animka[1])
		$Anim.seek(g.rndf(0.0,2.0))
		if type != 'player':
			move = true
			speed = g.rnd(6,10)
			if type == "laborer":
				default_scale = 0.3
				texture = load("res://Images/man_body2.png")
				$Face.texture = load("res://Images/man_face3.png")
				$Hair.texture = load("res://Images/man_hair1.png")
				$Top.texture = load("res://Images/man_clothing3.png")
			elif type == "black man":
				default_scale = 0.3
				texture = load("res://Images/man_body5.png")
				$Face.texture = load("res://Images/man_face4.png")
				$Hair.texture = load("res://Images/man_hair4.png")
				$Top.texture = load("res://Images/man_clothing1.png")
			elif type == "guy":
				default_scale = 0.26
				texture = load("res://Images/man_body.png")
				$Face.texture = load("res://Images/man_face2.png")
				$Hair.texture = load("res://Images/man_hair2.png")
				$Top.texture = load("res://Images/man_clothing2.png")
			elif type == "boss":
				default_scale = 0.29
				texture = load("res://Images/man_body.png")
				$Face.texture = load("res://Images/man_face1.png")
				$Hair.texture = load("res://Images/man_hair1.png")
				$Top.texture = load("res://Images/man_clothing4.png")
			elif type == "nudist":
				default_scale = 0.26
				texture = load("res://Images/man_body3.png")
				$Face.texture = load("res://Images/man_face2.png")
			elif type == "afro nudist":
				default_scale = 0.3
				texture = load("res://Images/man_body6.png")
				$Face.texture = load("res://Images/man_face4.png")
			elif type == "giant":
				default_scale = 0.38
				texture = load("res://Images/man_body4.png")
				$Face.texture = load("res://Images/man_face1.png")
				$Hair.texture = load("res://Images/man_hair1.png")
				$Top.texture = load("res://Images/man_clothing5.png")
			elif type == 'obstetrician':
				default_scale = 0.28
				texture = load("res://Images/man_body.png")
				$Face.texture = load("res://Images/man_face2.png")
				$Hair.texture = load("res://Images/man_hair5.png")
				$Top.texture = load("res://Images/man_clothing6.png")
			elif type == "girl swimmer":
				texture = load("res://Images/fem_body.png")
				$Hair.texture = load("res://Images/fem_hair%s.png"%g.rnd(1,4))
				var clothes = g.rnd(1,6)
				if clothes == 1: $Underwear.texture = load("res://Images/player_bikini.png")
				elif clothes == 2: $Underwear.texture = load("res://Images/player_lace up.png")
				elif clothes == 3: $Underwear.texture = load("res://Images/player_pasties.png")
				elif clothes == 4: $Underwear.texture = load("res://Images/player_swimsuit.png")
				elif clothes == 5:
					$Underwear.texture = load("res://Images/player_casual.png")
					$Top.texture = load("res://Images/player_undershirt.png")
				elif clothes == 6: $Underwear.texture = load("res://Images/player_casual.png")
			elif type == "girl nudist":
				texture = load("res://Images/fem_body.png")
				$Hair.texture = load("res://Images/fem_hair%s.png"%g.rnd(1,4))
		scale = Vector2(default_scale,default_scale)
func Collisions():
	get_parent().get_parent().get_node('../UI/Button').visible = false
	get_parent().get_parent().get_node('../UI/Button').text = ''
	var mysize = texture.get_size()/2*scale
	var myrect = Rect2(position.x-mysize.x/2,position.y-mysize.y/2,mysize.x,mysize.y)
	for o in get_parent().get_node('../Objs').get_children():
		var osize = o.texture.get_size()*o.scale/1.6
		var orect = Rect2(o.position.x-osize.x/2,o.position.y-osize.y/2,osize.x,osize.y)
		if myrect.intersects(orect):
			if o.type == 'door': Btn('street')
			elif o.type == 'to home': Btn('home')
			elif o.type == 'to bus': Btn('bus')
			elif o.type == 'to bus2':
				if g.location == "locker room":
					Btn("pool")
				else:
					Btn('bus')
			elif o.type == 'next':
				if g.location == 'pool':
					Btn("women's locker room")
			elif o.type == 'locations': Btn('locations')
			elif o.type == 'work': Btn('work')
			elif o.type == 'bathtub' or o.type == 'shower stall': Btn('wash')
			elif o.type == 'bed': Btn('sleep')
			elif o.type == 'wardrobe': Btn('dress up')
			elif o.type == 'fridge': Btn('eat')
			elif o.type == 'tv': Btn('watch television')
			elif o.type == 'swim': Btn('swim')
			elif o.type == 'swim2': Btn('swim')
			elif o.type == 'from cafe': Btn('bus')
			elif o.type == 'dance': Btn('dance')
	var NPCs = 0
	for c in get_parent().get_node('../Characters').get_children():
		var osize = c.texture.get_size()/1.5*c.scale
		var orect = Rect2(c.position.x-osize.x/2,c.position.y-osize.y/2,osize.x,osize.y)
		if orect.intersects(myrect) and c.type != 'player':
			if g.location in ['locker room','pool']:
				if c.type.find('girl') != -1:
					NPCs += 1
			elif c.type.find('girl') == -1:
				NPCs += 1
	if g.location == 'bus':
		if NPCs >= 4: Btn('gangbang #1')
	elif g.location == 'street':
		if NPCs >= 1: Btn('blowjob #1')
	elif g.location == 'office':
		if NPCs >= 1: Btn('can I leave early today, please?')
	elif g.location == 'home':
		if NPCs >= 1: Btn('defeated #1')
	elif g.location == 'beach':
		if NPCs >= 3: Btn('double penetration')
	elif g.location == 'cafe':
		if NPCs >= 1: Btn('can I have a hot dog, please?')
	elif g.location == 'nightclub':
		if NPCs >= 4: Btn('blowbang1')
	elif g.location in ['locker room','pool']:
		if NPCs >= 1: Btn('lesbian')
	elif g.location == 'hospital':
		if NPCs >= 1:
			if g.v.gestation >= 100: Btn('vaginal examination #2') 
			else: Btn('vaginal examination #1') 
func _process(dt):
	if type in ['swim','rug','door','carpet','dance']: z_index = 0
	#elif type in ['heart']: z_index = 1990
	else: z_index = int(global_position.y)
	process_priority = -z_index
	if target == null and move: target = Vector2(g.rnd(40,1200),g.rnd(330,620))
	elif move:
		position = position.move_toward(target,dt*speed)
		if position.distance_to(target) < 60: target = null
	if !g.drag and (g.building or !obj) and !g.coloring and g.can_drag:
		var tsize = texture.get_size()*scale
		tsize.x /= 3
		if obj: tsize.y /= 1.4
		tsize.y /= 1.4
		if Rect2(global_position.x-tsize.x/2,global_position.y-tsize.y/2,tsize.x,tsize.y).has_point(get_global_mouse_position()):
			g.hovernode = self
			Input.set_custom_mouse_cursor(g.chover)
			scale = Vector2(default_scale+0.01,default_scale+0.01)
		else:
			if g.hovernode == self:
				Input.set_custom_mouse_cursor(g.cdefault)
				g.hovernode = null
	if !Input.is_action_pressed("LMB"):
		if !obj: $Shadow.visible = true
		drag = false
		g.drag = false
		hover = 2
		if !obj and $Anim.speed_scale == 2: $Anim.speed_scale = g.rndf(animka[0],animka[1])
		if g.building and g.can_drag:
			get_parent().get_parent().get_node('../UI/HelpRemove').visible = true
			get_parent().get_parent().get_node('../UI/HelpRemove').text = 'You can Drag & Drop something'
		if get_parent().get_parent().get_node('../UI/Trash').visible and !obj:
			var osize = texture.get_size()/1.5*scale
			var orect = Rect2(position.x-osize.x/2,position.y-osize.y/2,osize.x,osize.y)
			var btnrect = get_parent().get_parent().get_node('../UI/Trash').get_rect()
			btnrect.size /= 10
			btnrect.position *= 1.05
			if orect.intersects(btnrect) and type != 'player':
				queue_free()
				g.last_node = null
				if !obj: $Shadow.visible = true
				drag = false
				g.drag = false
				Input.set_custom_mouse_cursor(g.cdefault)
				get_parent().get_parent().get_node('../UI/Button').visible = false
		get_parent().get_parent().get_node('../UI/HelpRemove').visible = false
		if g.last_node == null: get_parent().get_parent().get_node('../UI/Trash').visible = false
	elif drag:
		modulate.a = 1
		var movespeed = 10.0
		if type == 'player':
			if g.v.gestation > 30: movespeed = 1
			else: movespeed = clamp(g.arousal/5.0,1.0,10.0)
		else: get_parent().get_parent().get_node('../UI/Trash').visible = true
		global_position = lerp(global_position,get_global_mouse_position(),movespeed*dt)
		var yobj = 0
		if type in ['heart','square','frame']: yobj = -500
		elif type in ['tv']: yobj = -145
		elif type in ['wardrobe','shower stall','fridge','lamp']: yobj = -50
		elif type in ['table']: yobj = 50
		elif type in ['bathtub','bed']: yobj = 65
		elif type in ['chair','plant','candles','nightstand','sculpture']: yobj = 85
		elif type in ['rug']: yobj = 150
		elif type in ['carpet']: yobj = 240
		if type in ['door','window']: position = Vector2(clampf(position.x,50,1260),270)
		else: position = Vector2(clampf(position.x,50,1260),clampf(position.y,330+yobj,710))
		if !obj: get_parent().get_node('Player').Collisions()
		if g.location == 'home' and type == 'player': z_index = 3000
	elif !g.drag and g.can_drag:
		var tsize = texture.get_size()*scale
		tsize.x /= 3
		if obj: tsize.y /= 1.4
		tsize.y /= 1.4
		var objrect = Rect2(global_position.x-tsize.x/2,global_position.y-tsize.y/2,tsize.x,tsize.y)
		var dist = get_global_mouse_position().distance_to(objrect.position)
		if objrect.has_point(get_global_mouse_position()):
			if (g.building and obj) or (!obj and !g.building):
				var success = true
				if obj:
					for o in get_parent().get_children():
						var tsize2 = o.texture.get_size()*o.scale
						tsize2.x /= 3
						tsize2.y /= 1.4
						tsize2.y /= 1.4
						var objrect2 = Rect2(o.global_position.x-tsize2.x/2,o.global_position.y-tsize2.y/2,tsize2.x,tsize2.y)
						var dist2 = get_global_mouse_position().distance_to(objrect2.position)
						if o.scale > Vector2(o.default_scale,o.default_scale) and dist > dist2:
							success = false
							break
				if success:
					if g.building and obj: g.last_node = self
					move = false
					drag = true
					g.drag = true
					if !obj:
						$Shadow.visible = false
						get_parent().get_parent().get_node('../UI/Trash').visible = false
					if type != 'player':
						get_parent().get_parent().get_node('../UI/HelpRemove').visible = false
						get_parent().get_parent().get_node('../UI/Trash').visible = true
					Input.set_custom_mouse_cursor(g.cdrag)
					if !obj: $Anim.speed_scale = 2
					hover = 1
	if hover == 1:
		if scale.x < default_scale+0.01: scale = Vector2(scale.x+dt/5,scale.y+dt/5)
		else: hover = 0
	elif hover == 2:
		if scale.x > default_scale: scale = Vector2(max(scale.x-dt/5,default_scale),max(scale.y-dt/5,default_scale))
		else: hover = 0
func Btn(val):
	#!get_parent().get_parent().get_node('../UI/Button').visible or 
	if get_parent().get_parent().get_node('../UI/Button').text not in ['Bus','Locations','Street',"Women's locker room",'Pool']:
		val[0] = val[0].to_upper()
		get_parent().get_parent().get_node('../UI/Button').visible = true
		get_parent().get_parent().get_node('../UI/Button').text = val
